Includes the changes from third party vendor Solarflare to make
ptpd use hardware assistance provided by some of their NICs.
   This patch also include changes developed in-house to support
Solaris in general and Solaris on sparc platform. Solarflare
related changes will not be fed back upstream. Solaris related
changes will be contributed back upstream.

diff -r 3f1e7d35d0ab -r 821e8eadeaff COPYRIGHT
--- a/COPYRIGHT	Tue May 14 17:07:59 2013 -0700
+++ b/COPYRIGHT	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,6 @@
 /*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2012 George V. Neville-Neil, 
  *                         Steven Kreuzer, 
  *                         Martin Burnicki, 
diff -r 3f1e7d35d0ab -r 821e8eadeaff Makefile
--- a/Makefile	Tue May 14 17:07:59 2013 -0700
+++ b/Makefile	Sun Oct 27 22:49:29 2013 -0700
@@ -2,16 +2,12 @@
 
 VERSION = ptpd-2.2.0
 
-release:
-	(cd src; make clean)
-	mkdir $(VERSION)
-	(cd $(VERSION); \
-	ln -s ../src .; \
-	ln -s ../doc .; \
-	ln -s ../tools .; \
-	ln -s ../COPYRIGHT .; \
-	ln -s ../ChangeLog .; \
-	ln -s ../Makefile .; \
-	ln -s ../README .; \
-	ln -s ../RELEASE_NOTES .)
-	tar cvzf $(VERSION).tar.gz -L --exclude .o --exclude Doxygen --exclude .svn --exclude .dep --exclude core $(VERSION)
+build:
+	(cd src; gmake clean; gmake)
+
+install:
+	mkdir -p $(DESTDIR)/usr/lib/inet
+	ginstall -D -p -m 755 src/ptpd $(DESTDIR)/usr/lib/inet/ptpd
+	mkdir -p $(DESTDIR)/usr/share/man/man1m/
+	ginstall -D -p -m 444 src/ptpd2.8 $(DESTDIR)/usr/share/man/man1m/ptpd.1m
+	
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/Makefile
--- a/src/Makefile	Tue May 14 17:07:59 2013 -0700
+++ b/src/Makefile	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,4 @@
-# Makefile for ptpd2
+# Makefile for ptpd
 
 #
 # Compile time defines:
@@ -13,6 +13,7 @@
 #  -DPTPD_DBGV    adds all debug messages
 #
 #   -DPTPD_NO_DAEMON             forces option -c
+#  -DBSD_INTERFACE_FUNCTIONS: for OpenBSD
 #
 #   -PTP_EXPERIMENTAL            Allows non-standard compliant experimental options:
 #                                   -U: Hybrid mode
@@ -27,29 +28,35 @@
 RM = rm -f
 
 # start with CFLAGS += ..., so additional CFLAGs can be specified e.g. on the make command line
-CFLAGS += -Wall -g
-
+CFLAGS = -Wall -g -D_ISOC99_SOURCE -D_BSD_SOURCE -std=gnu99 -m64
+CPPFLAGS += -D_XOPEN_SOURCE=600 -D__EXTENSIONS__ -D_XPG4_2
 CFLAGS += -DRUNTIME_DEBUG
 #CFLAGS += -DPTPD_DBG
 #CFLAGS += -DPTPD_DBG2
 #CFLAGS += -DPTPD_DBGV
+#CFLAGS += -DPTPD_DUMP
 
 #CFLAGS += -DPTPD_NO_DAEMON
+#CFLAGS += -DBSD_INTERFACE_FUNCTIONS
 #CFLAGS += -DDBG_SIGUSR2_CHANGE_DOMAIN
-CFLAGS += -DDBG_SIGUSR2_CHANGE_DEBUG
+#CFLAGS += -DDBG_SIGRTMIN_LEAP_SECOND
+#CFLAGS += -DDBG_SIGUSR2_CHANGE_DEBUG
+#CFLAGS += -DPTPD_FULL_OPTIONS
 
-CFLAGS += -DPTP_EXPERIMENTAL
+#CFLAGS += -DPTP_EXPERIMENTAL
 
 LDFLAGS+= -lm -lrt
+LDFLAGS += -lnsl -lsocket -m64
 
-PROG = ptpd2
+PROG = ptpd
 SRCS = ptpd.c arith.c bmc.c protocol.c display.c\
-	dep/msg.c dep/net.c dep/servo.c dep/startup.c dep/sys.c dep/timer.c
+	dep/msg.c dep/net.c dep/servo.c dep/startup.c dep/sys.c dep/timer.c dep/time.c
 
 OBJS = $(SRCS:.c=.o)
 
 HDRS = ptpd.h constants.h datatypes.h \
-	dep/ptpd_dep.h dep/constants_dep.h dep/datatypes_dep.h
+	dep/ptpd_dep.h dep/constants_dep.h dep/datatypes_dep.h \
+        dep/sfxge_ioctl.h
 
 CSCOPE = cscope
 GTAGS = gtags
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/arith.c
--- a/src/arith.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/arith.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,5 +1,7 @@
 /*-
- * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
+ * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer,
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
  *
@@ -36,9 +38,12 @@
  * 
  */
 
+#include <math.h>
 #include "ptpd.h"
 
 
+double round (double __x);
+
 void 
 integer64_to_internalTime(Integer64 bigint, TimeInternal * internal)
 {
@@ -245,7 +250,7 @@
 }
 
 
-
+#if 0
 int check_timestamp_is_fresh2(TimeInternal * timeA, TimeInternal * timeB)
 {
 	int ret;
@@ -264,7 +269,7 @@
 	return check_timestamp_is_fresh2(timeA, &timeB);
 }
 
-
+#endif
 int
 isTimeInternalNegative(const TimeInternal * p)
 {
@@ -272,4 +277,52 @@
 }
 
 
+int64_t
+internalTime_to_scalar(TimeInternal *internal)
+{
+	return ((int64_t)internal->seconds * 1000000000LL)
+		+ (int64_t)internal->nanoseconds;
+}
 
+float
+secondsToMidnight(void) 
+{
+	TimeInternal now;
+ 
+	timerNow(&now);
+ 
+	// TODO should be 86400 - (now.seconds % 86400)
+	Integer32 stmI = (now.seconds - (now.seconds % 86400) + 86400) - 
+		now.seconds;
+ 
+	return (stmI + 0.0 - now.nanoseconds / 1E9);
+}
+ 
+
+float
+getPauseBeforeMidnight(Integer8 announceInterval) 
+{
+	return ((secondsToMidnight() <= getPauseAfterMidnight(announceInterval)) ?
+		secondsToMidnight() : getPauseAfterMidnight(announceInterval));
+}
+
+
+float
+getPauseAfterMidnight(Integer8 announceInterval) 
+{
+	return((LEAP_SECOND_PAUSE_PERIOD > 2 * pow(2,announceInterval)) ?
+	       LEAP_SECOND_PAUSE_PERIOD + 0.0  : 2 * pow(2,announceInterval) + 
+	       0.0);
+}
+
+
+int
+log2IntegerSaturateAtZero(LongDouble number)
+{
+    if (number <= 0) return 0;
+
+    number = log(number)/log(2);
+
+    return round(number);
+}
+
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/bmc.c
--- a/src/bmc.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/bmc.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,5 @@
 /*-
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
@@ -77,7 +78,7 @@
 
 	ptpClock->domainNumber = rtOpts->domainNumber;
 	ptpClock->slaveOnly = rtOpts->slaveOnly;
-	if(rtOpts->slaveOnly)
+	if(rtOpts->master_slave_mode == PTP_MODE_SLAVE)
 		rtOpts->clockQuality.clockClass = 255;
 
 /* Port configuration data set */
@@ -91,16 +92,17 @@
 	ptpClock->portIdentity.portNumber = NUMBER_PORTS;
 
 	/* select the initial rate of delayreqs until we receive the first announce message */
-	ptpClock->logMinDelayReqInterval = rtOpts->initial_delayreq;
+	ptpClock->minDelayReqInterval = rtOpts->initial_delayreq;
+	ptpClock->logMinDelayReqInterval = log2IntegerSaturateAtZero(rtOpts->initial_delayreq);
 
 	clearTime(&ptpClock->peerMeanPathDelay);
 
-	ptpClock->logAnnounceInterval = rtOpts->announceInterval;
+	ptpClock->logAnnounceInterval = log2IntegerSaturateAtZero(rtOpts->announceInterval);
 	ptpClock->announceReceiptTimeout = rtOpts->announceReceiptTimeout;
-	ptpClock->logSyncInterval = rtOpts->syncInterval;
+	ptpClock->logSyncInterval = log2IntegerSaturateAtZero(rtOpts->syncInterval);
 	ptpClock->delayMechanism = rtOpts->delayMechanism;
-	ptpClock->logMinPdelayReqInterval = DEFAULT_PDELAYREQ_INTERVAL;
-	ptpClock->versionNumber = VERSION_PTP;
+	ptpClock->logMinPdelayReqInterval = DEFAULT_LOG_PDELAYREQ_INTERVAL;
+	ptpClock->versionNumber = VERSION_PTP_PROTOCOL;
 
  	/*
 	 *  Initialize random number generator using same method as ptpv1:
@@ -145,9 +147,10 @@
 	ptpClock->timeSource = INTERNAL_OSCILLATOR;
 
 	/* UTC vs TAI timescales */
-	ptpClock->currentUtcOffsetValid = DEFAULT_UTC_VALID;
+	ptpClock->currentUtcOffsetValid = rtOpts->currentUtcOffsetValid;
 	ptpClock->currentUtcOffset = rtOpts->currentUtcOffset;
 	
+	/* TODO Should we clear the leap second flags? Unprogram leap second in kernel? */
 }
 
 
@@ -156,8 +159,10 @@
 {
 	/* make sure we revert to ARB timescale in Passive mode*/
 	if(ptpClock->portState == PTP_PASSIVE){
-		ptpClock->currentUtcOffsetValid = DEFAULT_UTC_VALID;
+		ptpClock->currentUtcOffsetValid = rtOpts->currentUtcOffsetValid;
 		ptpClock->currentUtcOffset = rtOpts->currentUtcOffset;
+
+		/* TODO Should we clear the leap second flags? Unprogram leap second in kernel? */
 	}
 	
 }
@@ -166,6 +171,16 @@
 /*Local clock is synchronized to Ebest Table 16 (9.3.5) of the spec*/
 void s1(MsgHeader *header,MsgAnnounce *announce,PtpClock *ptpClock, RunTimeOpts *rtOpts)
 {
+
+	Boolean previousLeap59 = FALSE, previousLeap61 = FALSE;
+	Integer16 previousUtcOffset = 0;
+
+	if (ptpClock->portState == PTP_SLAVE) {
+		previousLeap59 = ptpClock->leap59;
+		previousLeap61 = ptpClock->leap61;
+		previousUtcOffset = ptpClock->currentUtcOffset;
+	}
+
 	/* Current DS */
 	ptpClock->stepsRemoved = announce->stepsRemoved + 1;
 
@@ -193,12 +208,95 @@
 	/* set PTP_PASSIVE-specific state */
 	p1(ptpClock, rtOpts);
 
-	ptpClock->leap59 = ((header->flagField[1] & PTP_LI_61) == PTP_LI_59);
-	ptpClock->leap61 = ((header->flagField[1] & PTP_LI_61) == PTP_LI_61);
 	ptpClock->timeTraceable = ((header->flagField[1] & TIME_TRACEABLE) == TIME_TRACEABLE);
 	ptpClock->frequencyTraceable = ((header->flagField[1] & FREQUENCY_TRACEABLE) == FREQUENCY_TRACEABLE);
 	ptpClock->ptpTimescale = ((header->flagField[1] & PTP_TIMESCALE) == PTP_TIMESCALE);
 	ptpClock->timeSource = announce->timeSource;
+
+	
+	/* Leap second handling */
+
+        if (ptpClock->portState == PTP_SLAVE) {
+		/* We must not take leap second updates while a leap second
+		 * is in progress. This shouldn't happen but we should not
+		 * rely on the master behaving. We'll take the update when
+		 * the first announce arrives after the leap second has
+		 * completed.
+		 */
+		if (!ptpClock->leapSecondInProgress) {
+			ptpClock->leap59 = ((header->flagField[1] & PTP_LI_59) == PTP_LI_59);
+			ptpClock->leap61 = ((header->flagField[1] & PTP_LI_61) == PTP_LI_61);
+			
+			if(ptpClock->leap59 && ptpClock->leap61) {
+				ERROR("Both Leap59 and Leap61 flags set!\n");
+				toState(PTP_FAULTY, rtOpts, ptpClock);
+				return;
+			}
+
+			if ((previousLeap59 != ptpClock->leap59) || 
+		            (previousLeap61 != ptpClock->leap61)) {
+				/* Either a leap second has been set. Start
+				 * by cancelling any leap seconds already
+				 * programmed. */
+				ptpClock->leapSecondPending = FALSE;
+				timerStop(LEAP_SECOND_PENDING_TIMER, ptpClock->itimer);
+				timerStop(LEAP_SECOND_NOW_TIMER, ptpClock->itimer);
+#if !defined(__APPLE__)
+				unsetTimexFlags(STA_INS | STA_DEL,TRUE);
+#endif /* apple */
+				/* If one of the leap seconds is set, program
+				 * the kernel to make the change. Set a timer
+				 * to expire just before the leap second will
+				 * occur. */
+				if (ptpClock->leap59 || ptpClock->leap61) {
+#if !defined(__APPLE__)
+					if (rtOpts->noResetClock ||
+					    rtOpts->resetClockStartupOnly) {
+						WARNING("=== Leap second pending! "
+							"One second will be %s "
+							"at midnight\n",
+							ptpClock->leap61 ?
+							"added" : "deleted");
+					} else {
+						WARNING("=== Leap second pending! "
+							"Setting kernel to %s "
+							"one second at midnight\n",
+							ptpClock->leap61 ?
+							"add" : "delete");
+					
+						setTimexFlags(ptpClock->leap61 ?
+							      STA_INS : STA_DEL,
+							      FALSE);
+					}
+#else
+					WARNING("=== Leap second pending! "
+						"No kernel leap second "
+						"API support - expect a "
+						"clock jump at midnight!\n");
+#endif /* apple */
+					ptpClock->leapSecondPending = TRUE;
+					timerStart(LEAP_SECOND_PENDING_TIMER,
+						   secondsToMidnight() - 
+						   getPauseBeforeMidnight(ptpClock->logAnnounceInterval),
+						   ptpClock->itimer);
+				} else {
+					WARNING("=== Leap second event "
+						"aborted by GM!\n");
+				}
+			}
+		}
+
+		if((previousUtcOffset != ptpClock->currentUtcOffset) && 
+		   !ptpClock->leapSecondPending && 
+		   !ptpClock->leapSecondInProgress ) {
+			WARNING("=== UTC offset changed from %d to %d with "
+				"no leap second pending!\n",
+				previousUtcOffset, ptpClock->currentUtcOffset);
+		} else if( previousUtcOffset != ptpClock->currentUtcOffset) {
+			WARNING("=== UTC offset changed from %d to %d\n",
+				previousUtcOffset,ptpClock->currentUtcOffset);
+		}
+	}
 }
 
 
@@ -342,9 +440,7 @@
 		 RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	Integer8 comp;
-	
-	
-	if (rtOpts->slaveOnly)	{
+	if (rtOpts->master_slave_mode == PTP_MODE_SLAVE) {
 		s1(header,announce,ptpClock, rtOpts);
 		return PTP_SLAVE;
 	}
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/constants.h
--- a/src/constants.h	Tue May 14 17:07:59 2013 -0700
+++ b/src/constants.h	Sun Oct 27 22:49:29 2013 -0700
@@ -1,3 +1,33 @@
+/*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
+ * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
+ *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
+ * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
+ *
+ * All Rights Reserved
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+ * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+ * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
 #ifndef CONSTANTS_H_
 #define CONSTANTS_H_
 
@@ -9,7 +39,8 @@
 * and enumeration defined in the spec
  */
 
- #define MANUFACTURER_ID \
+#define PTP_VERSION_STRING "ptpdv2_2_0_0"
+#define MANUFACTURER_ID \
   "MaceG VanKempen;2.0.0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
 
 
@@ -17,21 +48,26 @@
 #define DEFAULT_INBOUND_LATENCY      	0       /* in nsec */
 #define DEFAULT_OUTBOUND_LATENCY     	0       /* in nsec */
 #define DEFAULT_NO_RESET_CLOCK       	FALSE
+#define DEFAULT_RESET_CLOCK_STARTUP_ONLY FALSE
+#define DEFAULT_NO_ADJUST_CLOCK      FALSE
 #define DEFAULT_DOMAIN_NUMBER        	0
-#define DEFAULT_DELAY_MECHANISM      	E2E     // TODO
+#define DEFAULT_DELAY_MECHANISM      	E2E
 #define DEFAULT_AP                   	10
 #define DEFAULT_AI                   	1000
 #define DEFAULT_DELAY_S              	6
-#define DEFAULT_ANNOUNCE_INTERVAL    	1      /* 0 in 802.1AS */
+#define DEFAULT_ANNOUNCE_INTERVAL    	2.0    /* 0 in 802.1AS */
+#define LEAP_SECOND_PAUSE_PERIOD        2      /* how long before/after leap */
+                                               /* second event we pause offset */
+                                               /* calculation */
 
 /* Master mode operates in ARB (UTC) timescale, without TAI+leap seconds */
 #define DEFAULT_UTC_OFFSET           	0
 #define DEFAULT_UTC_VALID            	FALSE
-#define DEFAULT_PDELAYREQ_INTERVAL   	1      /* -4 in 802.1AS */
+#define DEFAULT_LOG_PDELAYREQ_INTERVAL  1      /* -4 in 802.1AS */
 
-#define DEFAULT_DELAYREQ_INTERVAL    	0      /* new value from page 237 of the standard */
+#define DEFAULT_DELAYREQ_INTERVAL    	1.0    /* new value from page 237 of the standard */
 
-#define DEFAULT_SYNC_INTERVAL        	0      /* -7 in 802.1AS */  /* from page 237 of the standard */
+#define DEFAULT_SYNC_INTERVAL        	1.0    /* -7 in 802.1AS */  /* from page 237 of the standard */
 /* number of announces we need to lose until a time out occurs. Thus it is 12 seconds */
 #define DEFAULT_ANNOUNCE_RECEIPT_TIMEOUT 6     /* 3 by default */
 
@@ -49,7 +85,7 @@
 section 7.6.2.4, page 55:
 248     Default. This clockClass shall be used if none of the other clockClass definitions apply.
 13      Shall designate a clock that is synchronized to an application-specific source of time. The timescale distributed
-        shall be ARB. A clockClass 13 clock shall not be a slave to another clock in the domain. 
+        shall be ARB. A clockClass 13 clock shall not be a slave to another clock in the domain.
 */
 #define DEFAULT_CLOCK_CLASS		248
 #define DEFAULT_CLOCK_CLASS__APPLICATION_SPECIFIC_TIME_SOURCE	13
@@ -63,22 +99,34 @@
 */
 #define DEFAULT_CLOCK_ACCURACY		0xFE
 
-#define DEFAULT_PRIORITY1		128        
-#define DEFAULT_PRIORITY2		128        /* page 238, default priority is the midpoint, to allow easy control of the BMC algorithm */
+#define DEFAULT_PRIORITY1		248
+#define DEFAULT_PRIORITY2		248
 
 
-/* page 238:  τ, see 7.6.3.2: The default initialization value shall be 1.0 s.  */
-#define DEFAULT_CLOCK_VARIANCE 	        28768 /* To be determined in 802.1AS. */
-                                             
+#define DEFAULT_CLOCK_VARIANCE 	       -4000 /* To be determined in 802.1AS. */
+                                             /* We use the same value as in */
+                                             /* ptpdv1. */
+
 
 
 #define DEFAULT_MAX_FOREIGN_RECORDS  	5
 #define DEFAULT_PARENTS_STATS			FALSE
 
+/* Default time mode for master and slave modes */
+#define DEFAULT_MASTER_TIME_MODE        TIME_SYSTEM
+#define DEFAULT_SLAVE_TIME_MODE         TIME_SYSTEM
+
+/* For time both, default system time update interval */
+#define DEFAULT_SYSTEM_TIME_UPDATE_INTERVAL 1.0
+
+/* We don't allow the time to be set to before 1/1/1971 because this almost */
+/* certainly means something has gone very wrong */
+#define UTC_TIME_VALID_MINIMUM          (31536000)
+
 /* features, only change to refelect changes in implementation */
 #define NUMBER_PORTS      	1
-#define VERSION_PTP       	2
-#define TWO_STEP_FLAG    	TRUE
+#define VERSION_PTP_PROTOCOL	2
+#define TWO_STEP_FLAG    	0x02
 #define BOUNDARY_CLOCK    	FALSE
 #define SLAVE_ONLY		FALSE
 #define NO_ADJUST		FALSE
@@ -107,7 +155,7 @@
  * \brief Domain Number (Table 2 in the spec)*/
 
 enum {
-	DFLT_DOMAIN_NUMBER = 0, ALT1_DOMAIN_NUMBER, ALT2_DOMAIN_NUMBER, ALT3_DOMAIN_NUMBER
+  DFLT_DOMAIN_NUMBER = 0, ALT1_DOMAIN_NUMBER, ALT2_DOMAIN_NUMBER, ALT3_DOMAIN_NUMBER
 };
 
 /**
@@ -148,9 +196,13 @@
 
   /* non-spec timers */
   OPERATOR_MESSAGES_TIMER,  /* used to limit the operator messages */
-  TIMER_ARRAY_SIZE
+  LEAP_SECOND_PENDING_TIMER, /**<\brief timer used for handling leap second operations */
+  LEAP_SECOND_NOW_TIMER, /**<\brief Timer used to time moment of leap second */
+  TIMER_ARRAY_SIZE  /* this one is non-spec */
 };
 
+extern char *PTP_timer_dbg_string[];
+
 /**
  * \brief PTP states
  */
